package proj2

// You MUST NOT change what you import.  If you add ANY additional
// imports it will break the autograder, and we will be Very Upset.

import (
	"testing"
	"reflect"
	"github.com/nweaver/cs161-p2/userlib"
	//"encoding/json"
	//"encoding/hex"
	//"github.com/google/uuid"
	//"strings"
	//"errors"
)
/*

	OK YOU don't allow me to import container/list. I'll fill the test all of junks.
	Btw, I'm too lazy to copy-paste list.go source code here.
	Many codes below are generated by Python script.
	So enjoy your job!

	Recolic

 */

func TestPrepare(t *testing.T) {
	userlib.SetDebugStatus(false)
}

func TestInit(t *testing.T) {
	_, _py_gen_err0 := InitUser("unicode用户名测试", "同样是unicode的密码") // Should success.
	_, _py_gen_err1 := InitUser("longlonglonglong ", "asovbaouigbouiedhbgouiasbhfvouisadhbgvoiawdhbvodsiagvhdslakgvhdsalkgvhdsaoligvhdsaoigfvhdsaoifvghdsaoivghhdsa") // Should success.
	_, _py_gen_err2 := InitUser("longlonglonglong", "") // Should success.
	_, _py_gen_err3 := InitUser("longlonglonglongUserTest", "") // Should success.
	_, _py_gen_err4 := InitUser("bob", "foobar") // Should success.
	_, _py_gen_err5 := InitUser("alice", "fubar") // Should success.
	_, _py_gen_err6 := InitUser("alice", "fuckyou") // Should fail.
	_, _py_gen_err7 := InitUser("", "") // Should fail.
	_, _py_gen_err8 := InitUser("", "fuckyoudoabfuoaidshgb") // Should fail.
	_, _py_gen_err9 := InitUser("", "这是密码") // Should fail.
	if _py_gen_err0 != nil || _py_gen_err1 != nil || _py_gen_err2 != nil || _py_gen_err3 != nil || _py_gen_err4 != nil || _py_gen_err5 != nil {
		t.Error("Test InitUser failed.")
	}
	if _py_gen_err6 == nil || _py_gen_err7 == nil || _py_gen_err8 == nil || _py_gen_err9 == nil {
		t.Error("Test InitUser failed.")
	}
}

func TestGet(t *testing.T) {
	_, _py_gen_err0 := GetUser("bob", "foobar") // Should success.
	_, _py_gen_err1 := GetUser("alice", "fubar") // Should success.
	_, _py_gen_err2 := GetUser("alice", "") // Should fail.
	_, _py_gen_err3 := GetUser("", "") // Should fail.
	_, _py_gen_err4 := GetUser("a", "fubar") // Should fail.
	_, _py_gen_err5 := GetUser("bob", "fubar") // Should fail.
	_, _py_gen_err6 := GetUser("  \n\toauisdhvfusdahfvsaodugfvhdasouifvhdsaoifhdsaoigvhadsoighasdoighohasdhgfoidsah", "") // Should fail.
	_, _py_gen_err7 := GetUser("bob\n", "foobar") // Should fail.
	_, _py_gen_err8 := GetUser("bob", "foobar\r") // Should fail.
	_, _py_gen_err9 := GetUser("bob", "foobar ") // Should fail.
	_, _py_gen_err10 := GetUser("bob", "\000foobar") // Should fail.
	_, _py_gen_err11 := GetUser("bob", "foobar          doifvhbasdoigfbdsaouigbdsaoigfhbdsaoifhgsdahoifhgdsaoifhvsdoiadfhdsaoifhsadoifhsadoifh") // Should fail.
	_, _py_gen_err12 := GetUser("bob", "foobar          ") // Should fail.
	_, _py_gen_err13 := GetUser("bob", "foobar         ") // Should fail.
	_, _py_gen_err14 := GetUser("bob", "foobar中") // Should fail.
	_, _py_gen_err15 := GetUser("bob中", "foobar") // Should fail.
	_, _py_gen_err16 := GetUser("bob             ", "foobar") // Should fail.
	if _py_gen_err0 != nil || _py_gen_err1 != nil {
		t.Error("Test GetUser phase 1 failed.")
	}
	if _py_gen_err2 == nil || _py_gen_err3 == nil || _py_gen_err4 == nil || _py_gen_err5 == nil || _py_gen_err6 == nil || _py_gen_err7 == nil || _py_gen_err8 == nil || _py_gen_err9 == nil || _py_gen_err10 == nil || _py_gen_err11 == nil || _py_gen_err12 == nil || _py_gen_err13 == nil || _py_gen_err14 == nil || _py_gen_err15 == nil || _py_gen_err16 == nil {
		t.Error("Test GetUser phase 2 failed.")
	}
}

func TestStore(t *testing.T) {
	alice, _ := GetUser("alice", "fubar")

	alice.StoreFile(".", []byte("")) // Should success.
	alice.StoreFile("/usr/include/rlib/string.hpp", []byte("/*\n *\n * string.hpp string process utility.\n * Recolic Keghart <root@recolic.net>\n * MIT License\n *\n */\n\n#ifndef R_STRING_HPP\n#define R_STRING_HPP\n\n#include <rlib/require/cxx14>\n#include <rlib/class_decorator.hpp>\n#include <rlib/sys/os.hpp>\n\n#include <array>\n#include <vector>\n#include <string>\n#include <cstdarg>\n#include <cstdio>\n#include <cstdlib>\n#include <cstring>\n#include <stdexcept>\n#include <sstream>\n#include <type_traits>\n\nnamespace rlib {\n    // literals_format, format_string, stringformat\n    namespace impl {\n#ifndef RLIB_MINGW_DISABLE_TLS\n//#if RLIB_CXX_STD < 2017\n// Intel C++ compiler has a pending bug for `thread_local inline` variable.\n        thread_local extern stdstringstream to_string_by_sstream_ss;        \n        thread_local extern stdstringstream _format_string_helper_ss;\n//#else\n//        thread_local inline stdstringstream to_string_by_sstream_ss;        \n//        thread_local inline stdstringstream _format_string_helper_ss;\n//#endif\n#endif\n        template <typename VarT>\n        stdstring to_string_by_sstream(VarT &thing) {\n#ifdef RLIB_MINGW_DISABLE_TLS // Fix intel C++ bug https//software.intel.com/en-us/forums/intel-c-compiler/topic/784136\n                              // Also fix mingw bug. But much slower!\n            stdstringstream ss;\n#else\n            auto &ss = to_string_by_sstream_ss;\n            ss.str(stdstring());\n#endif\n            ss << thing;\n            return ss.str();\n        }\n\n        template<typename... Args>\n        stdstring _format_string_helper(const stdstring &fmt, Args... args) {\n#ifdef RLIB_MINGW_DISABLE_TLS // Fix intel C++ bug https//software.intel.com/en-us/forums/intel-c-compiler/topic/784136\n            stdstringstream ss;\n#else\n            auto &ss = _format_string_helper_ss; // cached stringstream is much quicker.\n            ss.str(stdstring());\n#endif\n            size_t pos = 0, prev_pos = 0;\n            stdarray<stdstring, sizeof...(args)> argsArr{to_string_by_sstream(args) ...};\n            size_t current_used_arg = 0;\n            bool discovered_escape_char = false;\n            while((pos = fmt.find(\"{}\", pos)) != stdstringnpos) {\n                if(pos != 0 && fmt[pos-1] == '\\\\') {\n                    // Invalid hit.\n                    discovered_escape_char = true;\n                    pos += 2;\n                }\n                else {\n                    stdstring cutted_tmp_str = fmt.substr(prev_pos, pos - prev_pos);\n                    if(discovered_escape_char) {\n                        // hand-written string replace. Replace `\\{}` to `{}`.\n                        size_t pos = 0;\n                        while((pos = cutted_tmp_str.find(\"\\\\{}\", pos)) != stdstringnpos) {\n                            cutted_tmp_str.erase(pos, 1);\n                            pos += 2;\n                        }\n                    }\n                    ss << cutted_tmp_str << argsArr[current_used_arg];\n                    pos += 2;\n                    prev_pos = pos;\n                    ++current_used_arg;\n                }\n            }\n            ss << fmt.substr(prev_pos);\n            return ss.str();\n        }\n        template<typename... Args>\n        inline stdstring format_string(const stdstring &fmt, Args... args) {\n            return _format_string_helper(fmt, args...);\n        }\n        template<>\n        inline stdstring format_string<>(const stdstring &fmt) {\n            return fmt;\n        }\n \n        /*\n        template<class MetaFmtArr, typename... Args>\n        constexpr stdstring format_string_meta(Args... args) {\n            return (args + ...);\n        }*/\n    }\n\n    // format_string_c, stringcformat\n    namespace impl {\n        inline char *_format_string_c_helper(const char *fmt, ...)\n        {\n            int n;\n            int size = stdstrlen(fmt);\n            char *p, *np;\n            va_list ap;\n\n            if ((p = (char *)malloc(size)) == NULL)\n                throw stdruntime_error(\"malloc returns null.\");\n\n            while (1) {\n                va_start(ap, fmt);\n                n = vsnprintf(p, size, fmt, ap);\n                va_end(ap);\n\n                if (n < 0)\n                    throw stdruntime_error(\"vsnprintf returns \" + stdto_string(n));\n                if (n < size)\n                    return p;\n\n                size = n + 1;\n\n                if ((np = (char *)realloc (p, size)) == NULL) {\n                    free(p);\n                    throw stdruntime_error(\"make_message realloc failed.\");\n                } else {\n                    p = np;\n                }\n            }\n        }\n        template<typename... Args>\n        stdstring format_string_c(const stdstring &fmt, Args... args)\n        {\n            char *res = _format_string_c_helper(fmt.c_str(), args ...);\n            stdstring s = res;\n            free(res);\n            return s;\n        }\n    }\n\n    class string  public stdstring {\n    public\n        using stdstringstring;\n        string()  stdstring() {}\n        string(const stdstring &s)  stdstring(s) {}\n        string(stdstring &&s)  stdstring(stdforward<stdstring>(s)) {}\n\n    private\n        template <typename T> struct as_helper {};\n        template <typename T>\n        T as(as_helper<T>) const {\n            if(empty()) return T();\n            return T(*this);\n        }\n        stdstring as(as_helper<stdstring>) const {\n            return stdmove(*this);\n        }\n        rlibstring as(as_helper<rlibstring>) const {\n            return stdmove(*this);\n        }\n        char as(as_helper<char>) const {\n            if(size() > 1)\n                throw stdinvalid_argument(\"Can not convert rlibstring to char size() > 1.\");\n            return size() == 0 ? '\\0'  *cbegin();\n        }\n        unsigned char as(as_helper<unsigned char>) const {\n            return static_cast<unsigned char>(as<char>());\n        }\n        bool as(as_helper<bool>) const {\n            if(*this == \"true\") {\n                return true;\n            }\n            else if(*this == \"false\") {\n                return false;\n            }\n            // Nothing is slower than throw(); Just test more cases...\n            else if(*this == \"1\" || *this == \"True\" || *this == \"TRUE\") {\n                return true;\n            }\n            else if(*this == \"0\" || *this == \"False\" || *this == \"FALSE\") {\n                return false;\n            }\n            throw stdinvalid_argument(\"Can not convert rlibstring to bool. Not matching any template.\");\n        }\n\n#define RLIB_IMPL_GEN_AS_NUMERIC(type, std_conv) \\\n        type as(as_helper<type>) const { \\\n            if(empty()) return 0; \\\n            return stdstd_conv(*this); \\\n        }\n\n        RLIB_IMPL_GEN_AS_NUMERIC(int, stoi)\n        RLIB_IMPL_GEN_AS_NUMERIC(long, stol)\n        RLIB_IMPL_GEN_AS_NUMERIC(unsigned long, stoul)\n        RLIB_IMPL_GEN_AS_NUMERIC(unsigned long long, stoull)\n        RLIB_IMPL_GEN_AS_NUMERIC(long long, stoll)\n        RLIB_IMPL_GEN_AS_NUMERIC(float, stof)\n        RLIB_IMPL_GEN_AS_NUMERIC(double, stod)\n        RLIB_IMPL_GEN_AS_NUMERIC(long double, stold)\n\n#define RLIB_IMPL_GEN_AS_ALIAS(new_type, old_type) \\\n        new_type as(as_helper<new_type>) const { \\\n            return static_cast<new_type>(as<old_type>()); \\\n        }\n\n        RLIB_IMPL_GEN_AS_ALIAS(unsigned int, unsigned long)\n        RLIB_IMPL_GEN_AS_ALIAS(unsigned short, unsigned long)\n        //RLIB_IMPL_GEN_AS_ALIAS(uint8_t, unsigned long)\n\n        RLIB_IMPL_GEN_AS_ALIAS(short, int)\n        //RLIB_IMPL_GEN_AS_ALIAS(int8_t, int)\n\n    public\n        template <typename T>\n        T as() const {\n            return stdforward<T>(as(as_helper<T>()));\n        }\n\n        stdvector<string> split(const char &divider = ' ') const {\n            const string &toSplit = *this;\n            stdvector<string> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(toSplit.substr(prev, curr - prev));\n                ++curr; // skip divider\n                prev = curr;\n            }\n            buf.push_back(toSplit.substr(prev));\n            return buf;\n        }\n        stdvector<string> split(const stdstring &divider) const {\n            const string &toSplit = *this;\n            stdvector<string> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(toSplit.substr(prev, curr - prev));\n                curr += divider.size(); // skip divider\n                prev = curr;\n            }\n            buf.push_back(toSplit.substr(prev));\n            return buf;\n        }\n        template <typename T>\n        stdvector<T> split_as(const char &divider = ' ') const {\n            const string &toSplit = *this;\n            stdvector<T> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(string(toSplit.substr(prev, curr - prev)).as<T>());\n                ++curr; // skip divider\n                prev = curr;\n            }\n            buf.push_back(string(toSplit.substr(prev)).as<T>());\n            return stdmove(buf);\n        }\n        template <typename T>\n        stdvector<T> split_as(const stdstring &divider) const {\n            const string &toSplit = *this;\n            stdvector<T> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(string(toSplit.substr(prev, curr - prev)).as<T>());\n                curr += divider.size(); // skip divider\n                prev = curr;\n            }\n            buf.push_back(string(toSplit.substr(prev)).as<T>());\n            return stdmove(buf);\n        }\n\n        template <class ForwardIterable>\n        string &join(const ForwardIterable &buffer) {\n            join(buffer.cbegin(), buffer.cend());\n            return *this;\n        }\n        template <class ForwardIterator>\n        string &join(ForwardIterator begin, ForwardIterator end) {\n            const string &toJoin = *this;\n            stdstring result;\n            for(ForwardIterator iter = begin; iter != end; ++iter) {\n                if(iter != begin)\n                    result += toJoin;\n                result += *iter;\n            }\n            return operator=(stdmove(result));\n        }\n\n        string &strip() {\n            strip(\" \\t\\r\\n\");\n            return *this;\n        }\n        template <typename CharOrStringOrView>\n        string &strip(const CharOrStringOrView &stripped) {\n            size_t len = size();\n            size_t begin = find_first_not_of(stripped);\n\n            if(begin == stdstringnpos) {\n                clear();\n                return *this;\n            }\n            size_t end = find_last_not_of(stripped);\n\n            erase(end + 1, len - end - 1);\n            erase(0, begin);\n            return *this;\n        }\n\n        string &replace(const stdstring &from, const stdstring &to) {\n            size_t _;\n            replace(from, to, _);\n            return *this;\n        }\n        string &replace(const stdstring &from, const stdstring &to, size_t &out_times) {\n            if(from.empty())\n                return *this;\n            size_t start_pos = 0;\n            size_t times = 0;\n            while((start_pos = find(from, start_pos)) != stdstringnpos)\n            {\n                ++times;\n                this->stdstringreplace(start_pos, from.length(), to);\n                start_pos += to.length(); // In case 'to' contains 'from', like replacing 'x' with 'yx'\n            }\n            out_times = times;\n            return *this;\n        }\n        string &replace_once(const stdstring &from, const stdstring &to) {\n            bool _;\n            replace_once(from, to, _);\n            return *this;\n        }\n        string &replace_once(const stdstring &from, const stdstring &to, bool &out_replaced) {\n            size_t start_pos = find(from);\n            if(start_pos == stdstringnpos) {\n                out_replaced = false;\n            }\n            else {\n                this->stdstringreplace(start_pos, from.length(), to);\n                out_replaced = true;\n            }\n            return *this;\n        }\n\n        template <typename... Args>\n        string &format(Args... args) {\n            return operator=(stdmove(implformat_string(*this, args ...)));\n        }\n        template <typename... Args>\n        string &cformat(Args... args) {\n            return operator=(stdmove(implformat_string_c(*this, args ...)));\n        }\n    };\n\n    namespace impl {\n        struct formatter {\n            formatter(const stdstring &fmt)  fmt(fmt) {}\n            formatter(stdstring &&fmt)  fmt(fmt) {}\n            template <typename... Args>\n            stdstring operator ()(Args... args) {\n                return stdmove(rlibimplformat_string(fmt, args ...));\n            }\n\n            stdstring fmt;\n        };\n    }\n\n    namespace literals {\n        inline implformatter operator \"\" _format (const char *str, size_t) {\n            return implformatter(str);\n        }\n        inline rlibstring operator \"\" _rs (const char *str, size_t len) {\n            return rlibstring(str, len);\n        }\n    }\n}\n\n#endif\n")) // Should success.
	alice.StoreFile("file3.log", []byte("这个文件是unicode的。\n他还有两行。")) // Should success.
	alice.StoreFile("file2.log", []byte("")) // Should success.
	alice.StoreFile("file1.log", []byte("fuckyou")) // Should success.
	alice.StoreFile("dfoubvuodfagbaouedisgbfodaibndaosibvnfdsaoibvnfdsaojgvbdsaouigvbadsoigvbasdoigvbdsaoigvasdoighasoighadsoipgvhasdoigvhbdsaoigvhbasdoipgvhnasd", []byte("")) // Should success.
	alice.StoreFile("", []byte("fuckyou")) // Should fail.

}

func TestLoad(t *testing.T) {
	alice, _ := GetUser("alice", "fubar")

	/*_py_gen_data0, _py_gen_err0 := alice.LoadFile(".") // Should success.
	if !reflect.DeepEqual(_py_gen_data0, []byte("")) {
		t.Error("Test alice.LoadFile failed. data 1 does not match.", _py_gen_data0, _py_gen_err0)
	}*/
	_py_gen_data1, _py_gen_err1 := alice.LoadFile("/usr/include/rlib/string.hpp") // Should success.
	if !reflect.DeepEqual(_py_gen_data1, []byte("/*\n *\n * string.hpp string process utility.\n * Recolic Keghart <root@recolic.net>\n * MIT License\n *\n */\n\n#ifndef R_STRING_HPP\n#define R_STRING_HPP\n\n#include <rlib/require/cxx14>\n#include <rlib/class_decorator.hpp>\n#include <rlib/sys/os.hpp>\n\n#include <array>\n#include <vector>\n#include <string>\n#include <cstdarg>\n#include <cstdio>\n#include <cstdlib>\n#include <cstring>\n#include <stdexcept>\n#include <sstream>\n#include <type_traits>\n\nnamespace rlib {\n    // literals_format, format_string, stringformat\n    namespace impl {\n#ifndef RLIB_MINGW_DISABLE_TLS\n//#if RLIB_CXX_STD < 2017\n// Intel C++ compiler has a pending bug for `thread_local inline` variable.\n        thread_local extern stdstringstream to_string_by_sstream_ss;        \n        thread_local extern stdstringstream _format_string_helper_ss;\n//#else\n//        thread_local inline stdstringstream to_string_by_sstream_ss;        \n//        thread_local inline stdstringstream _format_string_helper_ss;\n//#endif\n#endif\n        template <typename VarT>\n        stdstring to_string_by_sstream(VarT &thing) {\n#ifdef RLIB_MINGW_DISABLE_TLS // Fix intel C++ bug https//software.intel.com/en-us/forums/intel-c-compiler/topic/784136\n                              // Also fix mingw bug. But much slower!\n            stdstringstream ss;\n#else\n            auto &ss = to_string_by_sstream_ss;\n            ss.str(stdstring());\n#endif\n            ss << thing;\n            return ss.str();\n        }\n\n        template<typename... Args>\n        stdstring _format_string_helper(const stdstring &fmt, Args... args) {\n#ifdef RLIB_MINGW_DISABLE_TLS // Fix intel C++ bug https//software.intel.com/en-us/forums/intel-c-compiler/topic/784136\n            stdstringstream ss;\n#else\n            auto &ss = _format_string_helper_ss; // cached stringstream is much quicker.\n            ss.str(stdstring());\n#endif\n            size_t pos = 0, prev_pos = 0;\n            stdarray<stdstring, sizeof...(args)> argsArr{to_string_by_sstream(args) ...};\n            size_t current_used_arg = 0;\n            bool discovered_escape_char = false;\n            while((pos = fmt.find(\"{}\", pos)) != stdstringnpos) {\n                if(pos != 0 && fmt[pos-1] == '\\\\') {\n                    // Invalid hit.\n                    discovered_escape_char = true;\n                    pos += 2;\n                }\n                else {\n                    stdstring cutted_tmp_str = fmt.substr(prev_pos, pos - prev_pos);\n                    if(discovered_escape_char) {\n                        // hand-written string replace. Replace `\\{}` to `{}`.\n                        size_t pos = 0;\n                        while((pos = cutted_tmp_str.find(\"\\\\{}\", pos)) != stdstringnpos) {\n                            cutted_tmp_str.erase(pos, 1);\n                            pos += 2;\n                        }\n                    }\n                    ss << cutted_tmp_str << argsArr[current_used_arg];\n                    pos += 2;\n                    prev_pos = pos;\n                    ++current_used_arg;\n                }\n            }\n            ss << fmt.substr(prev_pos);\n            return ss.str();\n        }\n        template<typename... Args>\n        inline stdstring format_string(const stdstring &fmt, Args... args) {\n            return _format_string_helper(fmt, args...);\n        }\n        template<>\n        inline stdstring format_string<>(const stdstring &fmt) {\n            return fmt;\n        }\n \n        /*\n        template<class MetaFmtArr, typename... Args>\n        constexpr stdstring format_string_meta(Args... args) {\n            return (args + ...);\n        }*/\n    }\n\n    // format_string_c, stringcformat\n    namespace impl {\n        inline char *_format_string_c_helper(const char *fmt, ...)\n        {\n            int n;\n            int size = stdstrlen(fmt);\n            char *p, *np;\n            va_list ap;\n\n            if ((p = (char *)malloc(size)) == NULL)\n                throw stdruntime_error(\"malloc returns null.\");\n\n            while (1) {\n                va_start(ap, fmt);\n                n = vsnprintf(p, size, fmt, ap);\n                va_end(ap);\n\n                if (n < 0)\n                    throw stdruntime_error(\"vsnprintf returns \" + stdto_string(n));\n                if (n < size)\n                    return p;\n\n                size = n + 1;\n\n                if ((np = (char *)realloc (p, size)) == NULL) {\n                    free(p);\n                    throw stdruntime_error(\"make_message realloc failed.\");\n                } else {\n                    p = np;\n                }\n            }\n        }\n        template<typename... Args>\n        stdstring format_string_c(const stdstring &fmt, Args... args)\n        {\n            char *res = _format_string_c_helper(fmt.c_str(), args ...);\n            stdstring s = res;\n            free(res);\n            return s;\n        }\n    }\n\n    class string  public stdstring {\n    public\n        using stdstringstring;\n        string()  stdstring() {}\n        string(const stdstring &s)  stdstring(s) {}\n        string(stdstring &&s)  stdstring(stdforward<stdstring>(s)) {}\n\n    private\n        template <typename T> struct as_helper {};\n        template <typename T>\n        T as(as_helper<T>) const {\n            if(empty()) return T();\n            return T(*this);\n        }\n        stdstring as(as_helper<stdstring>) const {\n            return stdmove(*this);\n        }\n        rlibstring as(as_helper<rlibstring>) const {\n            return stdmove(*this);\n        }\n        char as(as_helper<char>) const {\n            if(size() > 1)\n                throw stdinvalid_argument(\"Can not convert rlibstring to char size() > 1.\");\n            return size() == 0 ? '\\0'  *cbegin();\n        }\n        unsigned char as(as_helper<unsigned char>) const {\n            return static_cast<unsigned char>(as<char>());\n        }\n        bool as(as_helper<bool>) const {\n            if(*this == \"true\") {\n                return true;\n            }\n            else if(*this == \"false\") {\n                return false;\n            }\n            // Nothing is slower than throw(); Just test more cases...\n            else if(*this == \"1\" || *this == \"True\" || *this == \"TRUE\") {\n                return true;\n            }\n            else if(*this == \"0\" || *this == \"False\" || *this == \"FALSE\") {\n                return false;\n            }\n            throw stdinvalid_argument(\"Can not convert rlibstring to bool. Not matching any template.\");\n        }\n\n#define RLIB_IMPL_GEN_AS_NUMERIC(type, std_conv) \\\n        type as(as_helper<type>) const { \\\n            if(empty()) return 0; \\\n            return stdstd_conv(*this); \\\n        }\n\n        RLIB_IMPL_GEN_AS_NUMERIC(int, stoi)\n        RLIB_IMPL_GEN_AS_NUMERIC(long, stol)\n        RLIB_IMPL_GEN_AS_NUMERIC(unsigned long, stoul)\n        RLIB_IMPL_GEN_AS_NUMERIC(unsigned long long, stoull)\n        RLIB_IMPL_GEN_AS_NUMERIC(long long, stoll)\n        RLIB_IMPL_GEN_AS_NUMERIC(float, stof)\n        RLIB_IMPL_GEN_AS_NUMERIC(double, stod)\n        RLIB_IMPL_GEN_AS_NUMERIC(long double, stold)\n\n#define RLIB_IMPL_GEN_AS_ALIAS(new_type, old_type) \\\n        new_type as(as_helper<new_type>) const { \\\n            return static_cast<new_type>(as<old_type>()); \\\n        }\n\n        RLIB_IMPL_GEN_AS_ALIAS(unsigned int, unsigned long)\n        RLIB_IMPL_GEN_AS_ALIAS(unsigned short, unsigned long)\n        //RLIB_IMPL_GEN_AS_ALIAS(uint8_t, unsigned long)\n\n        RLIB_IMPL_GEN_AS_ALIAS(short, int)\n        //RLIB_IMPL_GEN_AS_ALIAS(int8_t, int)\n\n    public\n        template <typename T>\n        T as() const {\n            return stdforward<T>(as(as_helper<T>()));\n        }\n\n        stdvector<string> split(const char &divider = ' ') const {\n            const string &toSplit = *this;\n            stdvector<string> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(toSplit.substr(prev, curr - prev));\n                ++curr; // skip divider\n                prev = curr;\n            }\n            buf.push_back(toSplit.substr(prev));\n            return buf;\n        }\n        stdvector<string> split(const stdstring &divider) const {\n            const string &toSplit = *this;\n            stdvector<string> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(toSplit.substr(prev, curr - prev));\n                curr += divider.size(); // skip divider\n                prev = curr;\n            }\n            buf.push_back(toSplit.substr(prev));\n            return buf;\n        }\n        template <typename T>\n        stdvector<T> split_as(const char &divider = ' ') const {\n            const string &toSplit = *this;\n            stdvector<T> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(string(toSplit.substr(prev, curr - prev)).as<T>());\n                ++curr; // skip divider\n                prev = curr;\n            }\n            buf.push_back(string(toSplit.substr(prev)).as<T>());\n            return stdmove(buf);\n        }\n        template <typename T>\n        stdvector<T> split_as(const stdstring &divider) const {\n            const string &toSplit = *this;\n            stdvector<T> buf;\n            size_t curr = 0, prev = 0;\n            while((curr = toSplit.find(divider, curr)) != stdstringnpos) {\n                buf.push_back(string(toSplit.substr(prev, curr - prev)).as<T>());\n                curr += divider.size(); // skip divider\n                prev = curr;\n            }\n            buf.push_back(string(toSplit.substr(prev)).as<T>());\n            return stdmove(buf);\n        }\n\n        template <class ForwardIterable>\n        string &join(const ForwardIterable &buffer) {\n            join(buffer.cbegin(), buffer.cend());\n            return *this;\n        }\n        template <class ForwardIterator>\n        string &join(ForwardIterator begin, ForwardIterator end) {\n            const string &toJoin = *this;\n            stdstring result;\n            for(ForwardIterator iter = begin; iter != end; ++iter) {\n                if(iter != begin)\n                    result += toJoin;\n                result += *iter;\n            }\n            return operator=(stdmove(result));\n        }\n\n        string &strip() {\n            strip(\" \\t\\r\\n\");\n            return *this;\n        }\n        template <typename CharOrStringOrView>\n        string &strip(const CharOrStringOrView &stripped) {\n            size_t len = size();\n            size_t begin = find_first_not_of(stripped);\n\n            if(begin == stdstringnpos) {\n                clear();\n                return *this;\n            }\n            size_t end = find_last_not_of(stripped);\n\n            erase(end + 1, len - end - 1);\n            erase(0, begin);\n            return *this;\n        }\n\n        string &replace(const stdstring &from, const stdstring &to) {\n            size_t _;\n            replace(from, to, _);\n            return *this;\n        }\n        string &replace(const stdstring &from, const stdstring &to, size_t &out_times) {\n            if(from.empty())\n                return *this;\n            size_t start_pos = 0;\n            size_t times = 0;\n            while((start_pos = find(from, start_pos)) != stdstringnpos)\n            {\n                ++times;\n                this->stdstringreplace(start_pos, from.length(), to);\n                start_pos += to.length(); // In case 'to' contains 'from', like replacing 'x' with 'yx'\n            }\n            out_times = times;\n            return *this;\n        }\n        string &replace_once(const stdstring &from, const stdstring &to) {\n            bool _;\n            replace_once(from, to, _);\n            return *this;\n        }\n        string &replace_once(const stdstring &from, const stdstring &to, bool &out_replaced) {\n            size_t start_pos = find(from);\n            if(start_pos == stdstringnpos) {\n                out_replaced = false;\n            }\n            else {\n                this->stdstringreplace(start_pos, from.length(), to);\n                out_replaced = true;\n            }\n            return *this;\n        }\n\n        template <typename... Args>\n        string &format(Args... args) {\n            return operator=(stdmove(implformat_string(*this, args ...)));\n        }\n        template <typename... Args>\n        string &cformat(Args... args) {\n            return operator=(stdmove(implformat_string_c(*this, args ...)));\n        }\n    };\n\n    namespace impl {\n        struct formatter {\n            formatter(const stdstring &fmt)  fmt(fmt) {}\n            formatter(stdstring &&fmt)  fmt(fmt) {}\n            template <typename... Args>\n            stdstring operator ()(Args... args) {\n                return stdmove(rlibimplformat_string(fmt, args ...));\n            }\n\n            stdstring fmt;\n        };\n    }\n\n    namespace literals {\n        inline implformatter operator \"\" _format (const char *str, size_t) {\n            return implformatter(str);\n        }\n        inline rlibstring operator \"\" _rs (const char *str, size_t len) {\n            return rlibstring(str, len);\n        }\n    }\n}\n\n#endif\n")) {
		t.Error("Test alice.LoadFile failed. data 2 does not match.")
	}
	_py_gen_data2, _py_gen_err2 := alice.LoadFile("file3.log") // Should success.
	if !reflect.DeepEqual(_py_gen_data2, []byte("这个文件是unicode的。\n他还有两行。")) {
		t.Error("Test alice.LoadFile failed. data 3 does not match.")
	}
	/*_py_gen_data3, _py_gen_err3 := alice.LoadFile("file2.log") // Should success.
	if !reflect.DeepEqual(_py_gen_data3, []byte("")) {
		t.Error("Test alice.LoadFile failed. data 4 does not match.")
	}*/
	_py_gen_data4, _py_gen_err4 := alice.LoadFile("file1.log") // Should success.
	if !reflect.DeepEqual(_py_gen_data4, []byte("fuckyou")) {
		t.Error("Test alice.LoadFile failed. data 5 does not match.")
	}
	/*_py_gen_data5, _py_gen_err5 := alice.LoadFile("dfoubvuodfagbaouedisgbfodaibndaosibvnfdsaoibvnfdsaojgvbdsaouigvbadsoigvbasdoigvbdsaoigvasdoighasoighadsoipgvhasdoigvhbdsaoigvhbasdoipgvhnasd") // Should success.
	if !reflect.DeepEqual(_py_gen_data5, []byte("")) {
		t.Error("Test alice.LoadFile failed. data 6 does not match.")
	}*/
	_, _py_gen_err6 := alice.LoadFile("shit") // Should fail.
	_, _py_gen_err7 := alice.LoadFile("file1.log ") // Should fail.
	_, _py_gen_err8 := alice.LoadFile("file1.log\n") // Should fail.
	_, _py_gen_err9 := alice.LoadFile("file1.lo") // Should fail.
	_, _py_gen_err10 := alice.LoadFile("file") // Should fail.
	_, _py_gen_err11 := alice.LoadFile("\t") // Should fail.
	_, _py_gen_err12 := alice.LoadFile("") // Should fail.
	if  _py_gen_err1 != nil || _py_gen_err2 != nil ||  _py_gen_err4 != nil{
		t.Error("Test alice.LoadFile 7 failed.")
	}
	if _py_gen_err6 == nil || _py_gen_err7 == nil || _py_gen_err8 == nil || _py_gen_err9 == nil || _py_gen_err10 == nil || _py_gen_err11 == nil || _py_gen_err12 == nil {
		t.Error("Test alice.LoadFile 8 failed.")
	}

}

func TestAppend(t *testing.T) {
	alice, _ := GetUser("alice", "fubar")

	_py_gen_err0 := alice.AppendFile("file1.log", []byte("")) // Should success.
	_py_gen_err1 := alice.AppendFile("file2.log", []byte("\n")) // Should success.
	_py_gen_err2 := alice.AppendFile("file2.log", []byte("")) // Should success.
	_py_gen_err3 := alice.AppendFile("file1.log", []byte("\nfuck again")) // Should success.
	_py_gen_err4 := alice.AppendFile("file", []byte("\000sadoiuvbdafiuvbvbsdaiuvbdoiusavnsouvbernogvnarsogbasd")) // Should fail.
	_py_gen_err5 := alice.AppendFile("", []byte("")) // Should fail.
	_py_gen_err6 := alice.AppendFile("", []byte("1")) // Should fail.
	if _py_gen_err0 != nil || _py_gen_err1 != nil || _py_gen_err2 != nil || _py_gen_err3 != nil {
		t.Error("Test alice.AppendFile 1failed.")
	}
	if _py_gen_err4 != nil || _py_gen_err5 == nil || _py_gen_err6 == nil {
		t.Error("Test alice.AppendFile 2 failed.")
	}

}

func TestAppendVerify(t *testing.T) {
	alice, _ := GetUser("alice", "fubar")

	_py_gen_data0, _py_gen_err0 := alice.LoadFile("file2.log") // Should success.
	if !reflect.DeepEqual(_py_gen_data0, []byte("\n")) {
		t.Error("Test alice.LoadFile failed. data does not match.")
	}
	_py_gen_data1, _py_gen_err1 := alice.LoadFile("file1.log") // Should success.
	if !reflect.DeepEqual(_py_gen_data1, []byte("fuckyou\nfuck again")) {
		t.Error("Test alice.LoadFile failed. data does not match.")
	}
	if _py_gen_err0 != nil || _py_gen_err1 != nil {
		t.Error("Test alice.LoadFile failed.")
	}
}

// hand-written test case
func TestUnauthorizedLoad(t *testing.T) {
	fake_alice, _ := GetUser("alice", "")

	_, err := fake_alice.LoadFile("file1.log")

	if err == nil  {
		t.Error("Test UnauthorizedLoad failed. Unauthorized user successfully loaded file content.")
	}
}

func TestShareAndReceive(t *testing.T) {
	alice, _ := GetUser("alice", "fubar")

	//////////////////////////////////// TEST SHARE AND RECEIVE

	/////////////////////// alice
	_py_gen_data0, _py_gen_err0 := alice.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data1, _py_gen_err1 := alice.ShareFile("file1.log", "bob") // Should success.
	_py_gen_data2, _py_gen_err2 := alice.ShareFile("file1.log", "bob") // Should success.
	_py_gen_data3, _py_gen_err3 := alice.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data4, _py_gen_err4 := alice.ShareFile("file1.log", "bob") // Should success.
	_, _py_gen_err5 := alice.ShareFile("file", "bob") // Should fail.
	_, _py_gen_err6 := alice.ShareFile("file1.log", "") // Should fail.
	_, _py_gen_err7 := alice.ShareFile("", "") // Should fail.
	_, _py_gen_err8 := alice.ShareFile("", "bob") // Should fail.
	_, _py_gen_err9 := alice.ShareFile("file1.log", "bob\n") // Should fail.
	_, _py_gen_err10 := alice.ShareFile("file1.log", "bob             ") // Should fail.
	_, _py_gen_err11 := alice.ShareFile("file2.log", "unicode用户名测") // Should fail.
	if _py_gen_err0 != nil || _py_gen_err1 != nil || _py_gen_err2 != nil || _py_gen_err3 != nil || _py_gen_err4 != nil {
		t.Error("Test alice.ShareFile failed.")
	}
	if _py_gen_err5 == nil || _py_gen_err6 == nil || _py_gen_err7 == nil || _py_gen_err8 == nil || _py_gen_err9 == nil || _py_gen_err10 == nil || _py_gen_err11 == nil {
		t.Error("Test alice.ShareFile failed.")
	}

	/////////////////////// bob
	bob, _ := GetUser("bob", "foobar")

	_py_gen_err100 := bob.ReceiveFile("file1.log", "alice", _py_gen_data2) // Should success.
	_py_gen_err101 := bob.ReceiveFile("file1.log", "alice", _py_gen_data2) // Should fail.
	_py_gen_err102 := bob.ReceiveFile("file1.log", "alice", _py_gen_data4) // Should success.
	_py_gen_err103 := bob.ReceiveFile("file3.log", "alice", _py_gen_data2) // Should fail.
	_py_gen_err104 := bob.ReceiveFile("file2.log", "alice", _py_gen_data0) // Should fail.
	_py_gen_err105 := bob.ReceiveFile("file1.log", "alice", _py_gen_data3) // Should fail.
	_py_gen_err106 := bob.ReceiveFile("file1.log", "alice", _py_gen_data3) // Should success.
	if _py_gen_err100 != nil || _py_gen_err102 != nil || _py_gen_err106 != nil {
		t.Error("Test bob.ReceiveFile failed.")
	}
	if _py_gen_err101 == nil || _py_gen_err103 == nil || _py_gen_err104 == nil || _py_gen_err105 == nil {
		t.Error("Test bob.ReceiveFile failed.")
	}

	_py_gen_data30, _py_gen_err30 := bob.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data31, _py_gen_err31 := bob.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data32, _py_gen_err32 := bob.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data33, _py_gen_err33 := bob.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data34, _py_gen_err34 := bob.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data35, _py_gen_err35 := bob.ShareFile("file2.log", "alice") // Should success.
	_py_gen_data36, _py_gen_err36 := bob.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data37, _py_gen_err37 := bob.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data38, _py_gen_err38 := bob.ShareFile("file1.log", "unicode用户名测试") // Should success.
	_py_gen_data39, _py_gen_err39 := bob.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data40, _py_gen_err40 := bob.ShareFile("file1.log", "alice") // Should success.
	_py_gen_data41, _py_gen_err41 := bob.ShareFile("file1.log", "bob") // Should success.
	_py_gen_data42, _py_gen_err42 := bob.ShareFile("file1.log", "alice") // Should success.
	_py_gen_data43, _py_gen_err43 := bob.ShareFile("file1.log", "bob") // Should success.
	_, _py_gen_err44 := bob.ShareFile(".", "longlonglonglong") // Should fail.
	_, _py_gen_err45 := bob.ShareFile("file3.log", "alice") // Should fail.
	if _py_gen_err30 != nil || _py_gen_err31 != nil || _py_gen_err32 != nil || _py_gen_err33 != nil || _py_gen_err34 != nil || _py_gen_err35 != nil || _py_gen_err36 != nil || _py_gen_err37 != nil || _py_gen_err38 != nil || _py_gen_err39 != nil || _py_gen_err40 != nil || _py_gen_err41 != nil || _py_gen_err42 != nil || _py_gen_err43 != nil {
		t.Error("Test bob.ShareFile failed.")
	}
	if _py_gen_err44 == nil || _py_gen_err45 == nil {
		t.Error("Test bob.ShareFile failed.")
	}

	/////////////////////// unicode username test
	unicodeTest, _ := GetUser("unicode用户名测试", "同样是unicode的密码")

	_py_gen_err130 := unicodeTest.ReceiveFile("file2.log", "bob", _py_gen_data31) // Should fail.
	_py_gen_err131 := unicodeTest.ReceiveFile("file2.log", "bob", _py_gen_data30) // Should success.
	_py_gen_err132 := unicodeTest.ReceiveFile("file2.log", "alice", _py_gen_data0) // Should success.
	_py_gen_err133 := unicodeTest.ReceiveFile("file2.log", "alice", _py_gen_data32) // Should fail.
	_py_gen_err134 := unicodeTest.ReceiveFile("file2.log", "bob", _py_gen_data35) // Should success.
	_py_gen_err135 := unicodeTest.ReceiveFile("file1.log", "bob", _py_gen_data38) // Should success.
	if _py_gen_err131 != nil || _py_gen_err132 != nil || _py_gen_err134 != nil || _py_gen_err135 != nil {
		t.Error("Test unicodeTest.ReceiveFile failed.")
	}
	if _py_gen_err130 == nil || _py_gen_err133 == nil {
		t.Error("Test unicodeTest.ReceiveFile failed.")
	}

	_py_gen_data60, _py_gen_err60 := unicodeTest.ShareFile("file2.log", "alice") // Should success.
	_py_gen_data61, _py_gen_err61 := unicodeTest.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data62, _py_gen_err62 := unicodeTest.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data63, _py_gen_err63 := unicodeTest.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data64, _py_gen_err64 := unicodeTest.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data65, _py_gen_err65 := unicodeTest.ShareFile("file2.log", "alice") // Should success.
	_py_gen_data66, _py_gen_err66 := unicodeTest.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data67, _py_gen_err67 := unicodeTest.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data68, _py_gen_err68 := unicodeTest.ShareFile("file2.log", "unicode用户名测试") // Should success.
	_py_gen_data69, _py_gen_err69 := unicodeTest.ShareFile("file2.log", "bob") // Should success.
	_py_gen_data70, _py_gen_err70 := unicodeTest.ShareFile("file1.log", "alice") // Should success.
	_py_gen_data71, _py_gen_err71 := unicodeTest.ShareFile("file1.log", "bob") // Should success.
	_py_gen_data72, _py_gen_err72 := unicodeTest.ShareFile("file1.log", "alice") // Should success.
	_py_gen_data73, _py_gen_err73 := unicodeTest.ShareFile("file1.log", "longlonglonglong") // Should success.
	_, _py_gen_err74 := unicodeTest.ShareFile(".", "longlonglonglong") // Should fail.
	_, _py_gen_err75 := unicodeTest.ShareFile("file3.log", "alice") // Should fail.
	if _py_gen_err60 != nil || _py_gen_err61 != nil || _py_gen_err62 != nil || _py_gen_err63 != nil || _py_gen_err64 != nil || _py_gen_err65 != nil || _py_gen_err66 != nil || _py_gen_err67 != nil || _py_gen_err68 != nil || _py_gen_err69 != nil || _py_gen_err70 != nil || _py_gen_err71 != nil || _py_gen_err72 != nil || _py_gen_err73 != nil {
		t.Error("Test unicodeTest.ShareFile failed.")
	}
	if _py_gen_err74 == nil || _py_gen_err75 == nil {
		t.Error("Test unicodeTest.ShareFile failed.")
	}

	longlonglonglong, _ := GetUser("longlonglonglong", "")

	_py_gen_err160 := longlonglonglong.ReceiveFile("file1.log", "unicode用户名测试", _py_gen_data73) // Should success.
	if _py_gen_err160 != nil {
		t.Error("Test longlonglonglong.ReceiveFile failed.")
	}

	_, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _ = _py_gen_data30, _py_gen_data31, _py_gen_data32, _py_gen_data33, _py_gen_data34, _py_gen_data35, _py_gen_data36, _py_gen_data37, _py_gen_data38, _py_gen_data39, _py_gen_data40, _py_gen_data41, _py_gen_data42, _py_gen_data43, _py_gen_data60, _py_gen_data61, _py_gen_data62, _py_gen_data63, _py_gen_data64, _py_gen_data65, _py_gen_data66, _py_gen_data67, _py_gen_data68, _py_gen_data69, _py_gen_data70, _py_gen_data71, _py_gen_data72, _py_gen_data73, _py_gen_data1

}

func TestWriteReceivedFile(t *testing.T) {
	longlonglonglong, _ := GetUser("longlonglonglong", "")

	_py_gen_err0 := longlonglonglong.AppendFile("file2.log", []byte("test"))     // Should fail.
	_py_gen_err1 := longlonglonglong.AppendFile("file1.log", []byte(""))         // Should success.
	_py_gen_err2 := longlonglonglong.AppendFile("file1.log", []byte("\n"))       // Should success.
	_py_gen_err3 := longlonglonglong.AppendFile("file1.log", []byte("fuckshit")) // Should success.
	if _py_gen_err1 != nil || _py_gen_err2 != nil || _py_gen_err3 != nil {
		t.Error("Test longlonglonglong.AppendFile failed.")
	}
	if _py_gen_err0 == nil {
		t.Error("Test longlonglonglong.AppendFile failed.")
	}

}

func TestWriteReceivedFileVerify(t *testing.T) {
	// verify previous test...
	bob, _ := GetUser("bob", "foobar")

	_py_gen_data10, _py_gen_err10 := bob.LoadFile("file2.log") // Should success.
	if !reflect.DeepEqual(_py_gen_data10, []byte("\n")) {
		t.Error("Test bob.LoadFile failed. data does not match.")
	}
	_py_gen_data11, _py_gen_err11 := bob.LoadFile("file1.log") // Should success.
	if !reflect.DeepEqual(_py_gen_data11, []byte("fuckyou\nfuck again\nfuckshit")) {
		t.Error("Test bob.LoadFile failed. data does not match.")
	}
	if _py_gen_err10 != nil || _py_gen_err11 != nil {
		t.Error("Test bob.LoadFile failed.")
	}
}

func TestUnauthorizedShare(t *testing.T) {
	// Already tested in TestShareAndReceive
}

func TestRevoke(t *testing.T) {
	// This test is hand-written.
	// Please see current file relationship: https://recolic.net/tmp/ftmpmap.png
	bob, _ := GetUser("bob", "foobar")

	err1 := bob.RevokeFile("file1.log"); // should succ
	err2 := bob.RevokeFile("."); // should fail
	err3 := bob.RevokeFile("file2.log"); // should succ
	if err1 != nil || err2 == nil || err3 != nil {
		t.Error("Test bob.RevokeFile failed.")
	}
}

func TestShareReadWriteAfterRevoke(t *testing.T) {
	// This test is hand-written.
	longlonglonglong, _ := GetUser("longlonglonglong", "")

	data1, err1 := longlonglonglong.LoadFile("file1.log") // should fail. the sharing chain already cut by bob.
	if err1 == nil || reflect.DeepEqual(data1, []byte("fuckyou\nfuck again\nfuckshit")) {
		t.Error("You failed to prevent user from accessing revoked share file.")
	}

	// unicode user can still access file2!
	unicodeTest, _ := GetUser("unicode用户名测试", "同样是unicode的密码")
	data2, err2 := unicodeTest.LoadFile("file2.log") // should success
	if err2 != nil || reflect.DeepEqual(data2, []byte("\n")) {
		t.Error("alice and bob both share to unicode and bob revoked, however, alice's doesn't work anymore. YOu failed again!")
	}

	// long try to update file1
	err3 := longlonglonglong.AppendFile("file1.log", []byte("fuckyou!")) // should fail. the sharing chain already cut by bob.
	if err3 == nil {
		t.Error("You failed to prevent user from writing to revoked share file.")
	}

	err4 := unicodeTest.AppendFile("file1.log", []byte(""))
	if err4 != nil {
		t.Error("...you failed again and again")
	}

	// HAHA let's verify file content again!
	TestWriteReceivedFileVerify(t)
}
